import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Sets up Enemy behaviors
 * 
 * Gsquared
 */
public class Enemies extends Mover
{
    private final GreenfootImage enemy1 = new GreenfootImage("enemy-1.png");// sets up the image that represents enemy type 1
    private final GreenfootImage enemy2 = new GreenfootImage("enemy-2.png");// sets up the image that represents enemy type 2
    private int enemyType; //helps the program easily determine what the enemy type is
    private boolean hitLeft; //helps determine what enemy type 2 should do if it hits the borders of the world
    private boolean isInWorld; //determines whether or not the enemy is in the world
    
    /**
     * Enemy constructor
     */
    public Enemies(int selection){
        enemyType = selection;
        isInWorld = true;
        if (selection == 0){
            this.speed = 7;
            setImage(enemy1);
            enemy1.scale(39, 114);
        }
        if (selection == 1){
            this.speed = 3;
            setImage(enemy2);
            enemy2.scale(39, 114);
        } 
    }
    
    /**
     * Determines the behavior of enemies
     */
    public void act() 
    {
        if (enemyType == 0){
            moveDown();
        }
        if (enemyType == 1){
            moveDown();
            if (hitLeft != true){
                moveLeft();
                if (getX() == 0){
                    hitLeft = true;
                }    
            }
            if (hitLeft == true){
                moveRight();
                if (getX() == 499){
                    hitLeft = false;
                }    
            }
        }
        if (getY() >= 745){
            getWorld().removeObject(this);
            isInWorld = false;
        }
        if (isInWorld == true){
            collisionDetection();
        }
    }
    
    /**
     * Checks if the enemy hit the player. If it did, the player dies.
     */
    private void collisionDetection(){
        Space S = (Space)getWorld();
        Counter scoreCounter = S.getScoreCounter();
        if(Player.isDead == false){
            if(getOneObjectAtOffset(-21,29, Player.class) != null || getOneObjectAtOffset(21,29, Player.class)
            != null){
                Player.isDead = true;
                getWorld().addObject(new DeadActor(), getX(), getY());
                scoreCounter.add(100);
                getWorld().removeObject(this);
            } 
        }    
    }
}
