import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Sets up the appearance and movement behaviors of projectiles
 * 
 * Gsquared
 */
public class Projectile extends Mover
{
    private final GreenfootImage plazer = new GreenfootImage("player-lazer.png"); //sets up the image that represents the lazer from the player
    private final GreenfootImage elazer = new GreenfootImage("enemy-lazer.png"); //sets up the image that represents the lazer from an enemy (not used)
    
    /**
     * Projectile contructor
     */
    public Projectile(int projtype){
        this.speed = 14;
        if (projtype == 1){
            setImage(plazer);
        }
        if (projtype == 2){
            setImage(elazer);
        }
    }
    
    /**
     * Determines the behavior of projectiles
     */
    public void act() 
    {
       moveUp();
       if (getY() <= 5){
            getWorld().removeObject(this);
       }else if(getOneObjectAtOffset(0, 2, Enemies.class) != null){
            Space S = (Space)getWorld();
            Counter scoreCounter = S.getScoreCounter();
            scoreCounter.add(100);
            getWorld().removeObject(getOneObjectAtOffset(0, 8, Enemies.class));
            getWorld().addObject(new DeadActor(), getX(), getY());
            getWorld().removeObject(this);
        }
    }    
}

